.include "include/tn26def.inc"       ;dolacz plik z nazwami rejestrow     
.def temp=r16
.def temp2=r17
.def adres=r18
.def zero=r19
.def prescaler=r20
.def prescaler_temp=r21
.def time=r22
.def t1start=r23
.def divider=r24
.def temp3=r25

rjmp reset

.org $006
rjmp timer0_int

reset:

   ldi temp,RAMEND              ;ostatnia kom. RAM 
   out SP,temp                  ;zpisz wskanik stosu 

   ldi temp,0b00001000          ;portb.3 wyjscie
   out ddrb,temp

   ldi temp,0b00001001          ;porta.0 i porta.3 wyjscia
   out ddra,temp

   clr adres

   ldi temp,4                   ;ustaw preskaler sprzetowy timera0 na 256
   out tccr0,temp

   rcall eeprom_read            ;ustaw preskaler programowy
   mov prescaler,temp


   rcall eeprom_read            ;ustaw preskaler programowy
   mov divider,temp
   

   ldi temp,0b00110001          ;wlacz kanal B pwm
   out tccr1a,temp

   clr zero

   ldi temp,0b00000010          ;wlacz przerwanie timer0 overflow
   out timsk,temp

   ldi t1start,0b00000101       ;dana do urucomninia timera1      
   
   sbi portb,4                  ;podciagnij do plusa portb,4
 
   sbis pinb,4                  ;jezeli portb,4=0 uruchom tryb pracy ciaglej
   rjmp nonstop
 
   sbi porta,0                  ;wlacz przekanik

   rcall wait
   rcall wait

loop:


sbic pina,2                     ;jezeli podniesiono sluchawke 
rjmp sluchawka



sbis pinb,6
rjmp zew

sbic pina,4
rjmp led

rjmp loop


sluchawka:
cbi porta,0                     ;przylacz aparat do linii

out tccr1b,zero
ldi adres,2
cli 

rcall wait                      ; zaczekaj az przekaznik zaskoczy

bitwait0:                       ;zaczekaj az zostanie odlozona
sbic pina,4
rjmp bitwait0

ldi temp3,25
wait6s:

rcall wait
dec temp3
brne wait6s

sbic pina,4
rjmp bitwait0

sbi porta,0

rjmp loop



led:
sbis pina,0
rjmp loop
sbi porta,3
rcall wait
cbi porta,3
rcall wait
rjmp loop




zew:
rcall start

bitwait1:                       ;zaczekaj az zostanie odlozona
sbis pinb,6
rjmp bitwait1

odnowa:
ldi temp3,50
wait4s:

sbic pina,2                     ;jezeli podniesiono sluchawke 
rjmp sluchawka

rcall wait

sbis pinb,6
rjmp odnowa

dec temp3
brne wait4s



out tccr1b,zero
ldi adres,2
cli 

rjmp loop





nonstop:                        ;tryb pracy ciaglej
   rcall start
nonstop_sub:
rjmp nonstop_sub


start:
   ldi prescaler_temp,1         ;zacznij rac od razu
   sei                          ;wlacz system przerwan
   out tccr1b,t1start           ;startuj timer
ret

wait:                           ;odczekaj 0.3s
ser temp                     
   wait_sub:
      ldi temp2,128
      wait_sub2:
         dec temp2
      brne wait_sub2
   dec temp 
   brne wait_sub
ret


timer0_int:
      
      out tcnt0,divider
 
      dec prescaler_temp        ;preskaler programowy
      brne end

      cpi adres,128             ;sprawdz czy nie skonczyla sie melodia
      breq koniec 

      rcall eeprom_read         ;odczytaj dlugosc nuty

      cpi temp,255                 ;sprawdz czy nie skonczyla sie melodia
      breq koniec

      mov time,temp
      clr temp 
      mov prescaler_temp,prescaler
   mull:                        ;nuta ma trwac dlugosc_nutyXpreskaler_programowy
      add temp,time 
      dec prescaler_temp
   brne mull

   mov prescaler_temp,temp
   rcall eeprom_read            ;odczytaj czestotliwosc dzweku

   tst temp                     ;sprawdz czy dzwiek nie jest pauza
   breq pauza

      out ocr1c,temp            ;wpisz liczbe do rejestru ocr1c (zmien czestotliwosc)
      lsr temp                  ;temp = temp/2
      out ocr1b,temp            ;wypelnienie =50%
      out tcnt1,zero            ;zeruj timer1
      out tccr1b,t1start        ;startuj timer

   rjmp end

   pauza:                       ;zastopuj timer1 jezeli nastapila pauza
      out tccr1b,zero
   rjmp end

   koniec:                      ;jezeli to byl ostatni dzwiek zeruj rejestr adresu
      out tccr1b,zero
      ldi adres,2
      ldi prescaler_temp,32     ;ustaw przerwe pomiedzy powtorzeniami dzwonka
   end:
reti

eeprom_read:
   out eear,adres               ;wyslij adres komorki pamieci eeprom	
   ldi temp,1
   out eecr,temp                ;uruchom odczyt
   in temp,eedr                 ;odczytaj dzwiek do temp
   inc adres                    ;zwieksz adres
ret